/*
 * Windows̕ǎύXR\[vOB
 * WXgXVȂꎞIȕύXȂ̂ŁAOIȂƈȑO̐ݒɖ߂B
 * g: changeWallPaper <t@C>
 *
 * 쐬: 2005/5/4
 * 쐬ҁFNAT (http://www9.plala.or.jp/NAT/)
 */
#include <stdio.h>
#include <Windows.h>

#define REGISTRY_VALUE_SIZE 10

static char path[MAX_PATH]; // ǎt@C̃pXǂݍݗp
static BOOL debug_mode = FALSE; // fobO[h
static BOOL noupdate_mode = FALSE; // XV[h([UvpeBXVȂ)
static char* file_name; // ǎɐݒ肷t@C

// R}hs̕ǎݒ̊i[p
static DWORD registry_value_size = REGISTRY_VALUE_SIZE;
static char tile_wallpaper[REGISTRY_VALUE_SIZE]; // ǎ^Cɕׂ("1")Azu("0")
static char wallpaper_style[REGISTRY_VALUE_SIZE]; // ǎg傷("2")AȂ("0")

static void showHelp(void) {
	printf("usage: chwp [-noupdate] [-debug] <ǎt@C>\n");
}

static int readOption(int argc, char* argv[]) {
	int i;

	if(argc < 2) {
		showHelp();
		return 1;
	}
	for(i = 1; i < argc-1; i++) {
		if(strcmp("-debug", argv[i]) == 0) {
			debug_mode = TRUE;
		} else if(strcmp("-noupdate", argv[i]) == 0) {
			noupdate_mode = TRUE;
		} else {
			showHelp();
			return 1;
		}
	}
	file_name = argv[argc-1];
	return 0;
}

int main(int argc, char* argv[])
{
	BOOL result; // APIĂяǒ
	HKEY registry_key; // WXgL[̃nh
	UINT fWinIni; // [Uvt@CXVtO
	
	if(readOption(argc, argv)) {
		return 1;
	}
	
	// WXg̓ǂݍ
	if(RegOpenKeyEx(HKEY_CURRENT_USER,"Control Panel\\Desktop",0,
			KEY_QUERY_VALUE|KEY_SET_VALUE, &registry_key) != ERROR_SUCCESS) {
		fprintf(stderr,
				"Failded to access registry 'HKEY_CURRENT_USER\\Control Panel\\Desktop'.\n");
		return 2;
	}
	if(noupdate_mode) {
		RegQueryValueEx(registry_key, "TileWallpaper", NULL,
				NULL, tile_wallpaper,
				&registry_value_size);
		RegQueryValueEx(registry_key, "WallpaperStyle", NULL,
				NULL, wallpaper_style, &registry_value_size);
	}

	// WXg̐ݒ
	RegSetValueEx(registry_key, "TileWallpaper", NULL, REG_SZ, "0", 2); // ǎ𒆉zu
	RegSetValueEx(registry_key, "WallpaperStyle", 0, REG_SZ, "0", 2); // ǎg債Ȃ
	RegFlushKey(registry_key);
		
	// ǎt@C̐ݒ
	fWinIni = (noupdate_mode) ? 0 : (SPIF_UPDATEINIFILE | SPIF_SENDCHANGE); 
	if(!SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, file_name, fWinIni)) {
		fprintf(stderr, "Failed to change wallpaper to '%s'.\n", file_name);
		return 1;
	}
	if(debug_mode) {
		printf("Suceeded to change '%s'\n", file_name);
		result = SystemParametersInfo(
			SPI_GETDESKWALLPAPER, MAX_PATH, path, SPIF_UPDATEINIFILE
		);
		if(result) {
			printf("now: %s\n", path);
		}
	}
	
	if(noupdate_mode) {
		// WXgɖ߂
		RegSetValueEx(registry_key, "TileWallpaper", NULL, REG_SZ,
				tile_wallpaper, strlen(tile_wallpaper));
		RegSetValueEx (registry_key, "WallpaperStyle", 0, REG_SZ,
				wallpaper_style, strlen(wallpaper_style));
	}
	RegCloseKey(registry_key);
	
	return 0;
}

