/*
 * 쐬: 2007/01/03
 */
package nat.sw;

import java.io.File;
import java.util.LinkedList;
import java.util.List;

/**
 * WallpaperDirectoryi[NX
 */
public class WallpaperDirectoryCollection {
    private WallpaperDirectory[] m_wallpaperDirectory;
    
    public WallpaperDirectoryCollection() {
        m_wallpaperDirectory = new WallpaperDirectory[0];
    }
    
    public WallpaperDirectoryCollection(
            WallpaperDirectory[] wallpaperDirectory) {
        m_wallpaperDirectory = wallpaperDirectory;
    }
    
    /**
     * wallpaperDirectory ԂB
     * @return wallpaperDirectory
     */
    public WallpaperDirectory[] getWallpaperDirectory() {
        return m_wallpaperDirectory;
    }

    /**
     * wallpaperDirectory ݒ肷B
     * @param wallpaperDirectory wallpaperDirectory
     */
    public void setWallpaperDirectory(WallpaperDirectory[] wallpaperDirectory) {
        m_wallpaperDirectory = wallpaperDirectory;
    }
    
    /**
     * SĂWallpaperDirectoryɊ܂܂ǎt@CW߂ĕԂB
     * AvpeBenablefalseWallpaperDirectorŷ̂
     * ܂܂Ȃ
     * @return
     * @throws MessageException
     */
    public List<File> collectFiles() throws MessageException {
        List<File> list = new LinkedList<File>();
        if(m_wallpaperDirectory != null) {
            for (WallpaperDirectory wd : m_wallpaperDirectory) {
                wd.collectFiles(list);
            }
        }
        return list;
    }
    
    /**
     * ŏɓo^ꂽWallpaperDirectoryԂB
     * Po^ĂȂꍇnullԂB
     * @return
     */
    public WallpaperDirectory getFirstWallpaperDirectory() {
        if(m_wallpaperDirectory.length > 0) {
            return m_wallpaperDirectory[0];
        }
        return null;
    }
    
    /**
     * WallpaperDirectoryCollectioñRs[ԂB
     * WallpaperDirectoryRs[[Rs[B
     * @param target
     * @return
     */
    public WallpaperDirectoryCollection copy() {
        WallpaperDirectory[] wds = 
            new WallpaperDirectory[getWallpaperDirectory().length];
        for(int i = 0; i < wds.length; i++) {
            wds[i] = getWallpaperDirectory()[i].copy();
        }
        return new WallpaperDirectoryCollection(wds);
    }
    
}
