/*
 * 쐬: 2005/07/18
 */
package nat.sw.tray;

import nat.sw.Configuration;
import nat.sw.ShuffleWallpaper;

/**
 * IntervalShuffleThreadNE~邽߂̃NX
 */
public class IntervalShuffleThreadManager {
    /** sIntervalShuffleThread */
    private IntervalShuffleThread m_intervalShuffleThread = null;
    /** ǎύXɎgShuffleWallpaper */
	private ShuffleWallpaper m_shuffleWallpaper = null;
	/** ǎɊւݒ */
	private Configuration m_configuration;
    
	/**
	 * IntervalShuffleThreadJnB
	 * ɋNĂIntervalShuffleThread΁A
	 * ~ĂAVKɋNB
	 */
    public synchronized void start() {
        if(m_intervalShuffleThread != null) {
            stop();
        }
        m_intervalShuffleThread = new IntervalShuffleThread();
        m_intervalShuffleThread.setShuffleWallpaper(m_shuffleWallpaper);
        m_intervalShuffleThread.setConfiguration(m_configuration);
        m_intervalShuffleThread.setDaemon(true);
        m_intervalShuffleThread.start();            
    }

    /**
     * IntervalShuffleThread~B
     * NĂIntervalShuffleThreadȂ΁A
     * ȂB
     */
    public synchronized void stop() {
        if(m_intervalShuffleThread != null) {
            m_intervalShuffleThread.stopRunning();
            m_intervalShuffleThread = null;
        }
    }
    /**
     * ǎɊւݒWallpaperConfigurationݒB
     */
    public void setConfiguration(Configuration configuration) {
        m_configuration = configuration;
    }
    public Configuration getConfiguration() {
        return m_configuration;
    }
    
    /**
     * ǎύXɎgShuffleWallpaperݒB
     */
    public void setShuffleWallpaper(ShuffleWallpaper shuffleWallpaper) {
        m_shuffleWallpaper = shuffleWallpaper;
    }
    public ShuffleWallpaper getShuffleWallpaper() {
        return m_shuffleWallpaper;
    }
}
