/*
 * 쐬: 2005/07/17
 */
package nat.sw.tray.config;

import java.awt.BorderLayout;

import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * ݂̐l\̃XC_[
 */
public class SliderWithValue extends JPanel {
    /** l\ɎgP */
    private String m_unit = "";
    /** l\p̃x */
    private JLabel m_valueLabel = new JLabel();
    /** XC_[ */
    private JSlider m_slider = new JSlider();
    
    /**
     * RXgN^
     */
    public SliderWithValue() {
        init();
    }
    
    private void init() {
        setLayout(new BorderLayout());
        m_valueLabel.setHorizontalAlignment(SwingConstants.CENTER);
        add(m_valueLabel, BorderLayout.SOUTH);
        add(m_slider, BorderLayout.CENTER);
        
        m_slider.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent e) {
                updateValueLabel();
            }
        });
        updateValueLabel();
    }
    
    /**
     * l\XC_[̌ݒlōXVB
     */
    public void updateValueLabel() {
        m_valueLabel.setText(
                Integer.toString(m_slider.getValue()) + m_unit);
    }
    
    /**
     * @return XC_[(JSlider)ԂB
     */
    public JSlider getSlider() {
        return m_slider;
    }
    
    /**
     * l擾
     */
    public int getValue() {
        return m_slider.getValue();
    }
    
    /**
     * lݒ肷
     */
    public void setValue(int value) {
        m_slider.setValue(value);
    }
    
    /**
     * l\ɎgPʂԂB
     */
    public String getUnit() {
        return m_unit;
    }
    /**
     * l\ɎgPʂݒB
     */
    public void setUnit(String unit) {
        m_unit = unit;
    }
    /**
     * l\p̃xԂB
     */
    public JLabel getValueLabel() {
        return m_valueLabel;
    }
}
