/*
 * 쐬: 2005/05/04
 */
package nat.sw;

import java.awt.Color;
import java.beans.XMLDecoder;
import java.beans.XMLEncoder;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

/**
 * ݒ\NXB
 * ݒvpeBt@CɕۑB
 */
public class Configuration {
    // ݒ̒l
    private String m_wallpaperFile;
    private Color m_backgroundColor;
    private long m_shuffleInterval;
    private boolean m_intervalRunning;
    private WallpaperDirectoryCollection
        m_wallpaperDirectoryCollection = new WallpaperDirectoryCollection();
    private boolean m_useImageReaderFileFilter = true;
    
    /**
     * ǎύXR}h
     * ǎt@C(΃pX)ʒu % B
     * F"chwp %"
     */
    private String m_command;
    
    /**
     * ݒt@CǂݍށB
     * @throws IOException ǂݍ݂Ɏsꍇ
     */
    public static Configuration load(String file) throws IOException {
        InputStream in = new FileInputStream(file);
        XMLDecoder decoder = new XMLDecoder(new BufferedInputStream(in));
        return (Configuration)decoder.readObject();
    }
    
    /** ݂̃vpeBvpeBt@Cɏ */
    public void save(String file) throws IOException {
        FileOutputStream out = new FileOutputStream(file);
        XMLEncoder encoder = new XMLEncoder(new BufferedOutputStream(out));
        encoder.writeObject(this);
        encoder.close();
    }

    /**
     * ǎ̐ݒɎgt@CԂ
     * @return ǎ̐ݒɎgt@C
     */
    public String getWallpaperFile() {
        return m_wallpaperFile;
    }
    
    /**
     * ǎ̐ݒɎgt@Cݒ肷
     * @param wallpaperFile
     */
    public void setWallpaperFile(String wallpaperFile) {
        m_wallpaperFile = wallpaperFile;
    }

    /**
     * ǎ̔wiFԂ
     * @return ǎ̔wiF
     */
    public Color getBackgroundColor() {
        return m_backgroundColor;
    }
    public void setBackgroundColor(Color backgroundColor) {
        m_backgroundColor = backgroundColor;
    }
    

    /** 
     * ǎύXԊu~bPʂŕԂB
     * @return
     */
    public long getShuffleInterval() {
        return m_shuffleInterval;
    }
    
    /** 
     * ǎύXԊu𕪒P(bȉ؎̂)ŕԂB
     * @return
     */    
    public long getShuffleIntervalMinute() {
        return m_shuffleInterval / (60 * 1000);
    }
    public void setShuffleIntervalMinute(long minute) {
        m_shuffleInterval = minute * 60 * 1000;
    }
    
    /**
     * ԂɕǎύX邩ǂԂB
     * @return trueȂAԂɕǎύX
     */
    public boolean isIntervalRunning() {
        return m_intervalRunning;
    }

    /**
     * ԂɕǎύX邩ǂݒ肷B
     * @param intervalRunning trueȂ玞ԂɕǎύX
     */
    public void setIntervalRunning(boolean intervalRunning) {
        m_intervalRunning = intervalRunning;
    }

    /**
     * ǎfBNg̃RNVԂB
     * @return wallpaperDirectoryCollection
     */
    public WallpaperDirectoryCollection getWallpaperDirectoryCollection() {
        return m_wallpaperDirectoryCollection;
    }

    /**
     * ǎfBNg̃RNVݒ肷B
     * @param wallpaperDirectoryCollection wallpaperDirectoryCollection
     */
    public void setWallpaperDirectoryCollection(
            WallpaperDirectoryCollection wallpaperDirectoryCollection) {
        m_wallpaperDirectoryCollection = wallpaperDirectoryCollection;
    }

    /**
     * 摜IɁA摜t@C̔(ImageReaderFileFilter)
     * gǂԂB
     * @return 摜t@C̔s
     */
    public boolean isUseImageReaderFileFilter() {
        return m_useImageReaderFileFilter;
    }

    /**
     * 摜IɁA摜t@C̔(ImageReaderFileFilter)
     * gǂݒ肷B
     * @param useImageReaderFileFilter trueȂ摜t@C𔻒肷
     */
    public void setUseImageReaderFileFilter(boolean useImageReaderFileFilter) {
        m_useImageReaderFileFilter = useImageReaderFileFilter;
    }

    /**
     * @return ǎύXR}h
     */
    public String getCommand() {
        return m_command;
    }

    /**
     * @param command ǎύXR}hݒB
     */
    public void setCommand(String command) {
        m_command = command;
    }
    
}
