/*
 * 쐬: 2005/05/04
 */
package nat.sw;

import java.io.File;
import java.io.IOException;

/**
 * OR}hŕǎύXWallpaperChanger
 */
public class ExecWallpaperChanger implements WallpaperChanger {
    /**
     * OR}h̃R}hB
     * ǎ̃t@Cw肷ӏ'%'w肷B
     * F"chwp '%'"
     */
    private String m_command = null;

    /** 
     * OR}hNĕǎύXB
     * @see nat.sw.WallpaperChanger#change(java.io.File)
     */
    public void change(File imageFile) throws MessageException {
        if(!imageFile.canRead()) {
            throw new MessageException(
                    "ExecWallpaperChanger.failedToReadFile",
                    imageFile);
        }
        
        // replaceAll()'\'GXP[vƉ߂邽߁ApX'\''\\'ɕϊ
        String path = imageFile.getAbsolutePath().replaceAll("\\\\", "\\\\\\\\"); 
        String command = m_command.replaceAll("%", path);
        Process process = null;
        try {
            process = Runtime.getRuntime().exec(command);
        } catch(IOException e) {
            Messenger.exceptionThrown(e);
            throw new MessageException(
                    "ExecWallpaperChanger.failedToExec",
                    e.getMessage());
        }
        
        try {
            int result = process.waitFor();
            if(result != 0) {
                MessageException e = new MessageException(
                        "ExecWallpaperChanger.commandReturnsNotZero",
                        new Object[]{new Integer(result), command});
                Messenger.exceptionThrown(e);
                throw e;
            }
        } catch(InterruptedException e) {
            // Ȃ
        }
    }

    public void setCommand(String command) {
        m_command = command;
    }
}
