/*
 * 쐬: 2005/06/12
 */
package nat.sw;

/**
 * bZ[WO
 */
public class MessageException extends Exception {
    private static final long serialVersionUID = 1L;
    
    private Message m_message;
    
    public MessageException(Message message) {
        m_message = message;
    }
    
    public MessageException(String messageKey) {
        this(new Message(messageKey));
    }
    
    public MessageException(String messageKey, Object arg0) {
        this(new Message(messageKey, arg0));
    }
    
    public MessageException(String messageKey, Object[] args) {
        this(new Message(messageKey, args));
    }

    public Message getErrorMessage() {
        return m_message;
    }
}
