/*
 * 쐬: 2005/06/12
 */
package nat.sw;

/**
 * WG[o͂ɃbZ[Wo͂MessengerImplementor
 */
public class SystemErrMessengerImplementor extends ResouceBundleMessengerImplmentor {
    
    public void showError(Message message) {
        System.err.print(getErrorCaption());
        System.err.print(": ");
        System.err.println(getString(message));
    }

    public void showWarning(Message message) {
        System.err.print(getWarningCaption());
        System.err.print(": ");
        System.err.println(getString(message));
    }

    public void showInformation(Message message) {
        System.err.print(getInformationCaption());
        System.err.print(": ");
        System.err.println(getString(message));
    }

    public void exceptionThrown(Exception e) {
        if(e instanceof MessageException) {
            System.err.println(
                    getString(((MessageException)e).getErrorMessage()));
        }        
        System.err.println(e.getMessage());
        e.printStackTrace();
    }
    
    public String getString(Message message) {
        // s󔒕ɒu
        return Messages.getString(message).replaceAll("\n", " ");
    }
}
