/*
 * 쐬: 2005/05/03
 */
package nat.sw;

import java.io.File;
import java.util.List;
import java.util.Random;


/**
 * ǎt@C_Ɍ肷NX
 */
public class WallpaperShuffler {
    /** ShuffleWallpaper̃R|[lgێRei */
    private ShuffleWallpaperContainer m_container;
    
    /**
     * RXgN^B
     * @param container ShuffleWallpaper̃R|[lgێRei
     */
    public WallpaperShuffler(ShuffleWallpaperContainer container) {
        m_container = container;
    }
    
    /**
     * ɕ\ǎ̉摜t@C_Ɍ肷B
     * @return ̕ǎ̉摜t@C
     * @throws MessageException ǎ̌ɎsꍇB
     */
    public File getNextWallpaper() throws MessageException {
        List<File> wallpaperList = m_container.getConfiguration()
                .getWallpaperDirectoryCollection().collectFiles();
        if(wallpaperList.size() == 0) {
            throw new MessageException(
                    "DirectoryWallpaperShuffler.directoryHasNoFile");
        }
        
        Random random = new Random();
        int index = random.nextInt(wallpaperList.size());
        return (File)wallpaperList.get(index);        
    }
}
