/*
 * 쐬: 2005/05/04
 */
package nat.sw;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.DisplayMode;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.io.File;

/**
 * Windows̕ǎɊւԂ
 */
public class WindowsWallpaperEnvironment implements WallpaperEnvironment {
    /** ǎɊւݒ */
    private Configuration m_configuration;
    
    /**
     * ǎ̃TCYƂāAʂ̉𑜓xԂB
     * @return ǎ̃TCY
     */
    public Dimension getSize() {
        // ftHg̕`foCX擾
        GraphicsDevice device = GraphicsEnvironment
        							.getLocalGraphicsEnvironment()
        							.getDefaultScreenDevice();
        DisplayMode mode = device.getDisplayMode();
        return new Dimension(mode.getWidth(), mode.getHeight());
    }

    /**
     * ǎ`悷̈ƂāAfXNgbv̗̈(^XNo[)Ԃ
     * @return ǎ`悷̈
     */
    public Rectangle getBounds() {
        // fXNgbv̈\Rectangle擾
        return GraphicsEnvironment.getLocalGraphicsEnvironment()
        							.getMaximumWindowBounds();
    }

    /**
     * ǎɐݒ肷t@CԂB
     * @return ǎɐݒ肷t@C
     * @see nat.sw.WallpaperEnvironment#getFile()
     */
    public File getFile() {
        return new File(m_configuration.getWallpaperFile());
    }

    /**
     * ǎ̔wiFԂ
     * @see nat.sw.WallpaperEnvironment#getBackgroundColor()
     */
    public Color getBackgroundColor() {
        return m_configuration.getBackgroundColor();
    }
    
    /**
     * ǎɊւݒݒ肷B
     */
    public void setConfiguration(Configuration configuration) {
        m_configuration = configuration;
    }
}
