/*
 * 쐬: 2005/07/10
 */
package nat.sw.tray.config;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JPanel;

/**
 * FItB[h
 */
public class ColorChooserField extends JPanel {
    /** IF */
	private Color m_color = Color.BLACK;
	
	
	private JPanel m_colorPanel = new JPanel();
	private String m_chooseDialogTitle;
	
	/**
	 * RXgN^
	 * @param chooseButtonLabel F̑I_CAO\{^ɕ\镶
	 * @param chooseDialogTitle F̑I_CAOɕ\^Cg
	 */
	public ColorChooserField(
	    String chooseButtonLabel, String chooseDialogTitle) {
		m_chooseDialogTitle = chooseDialogTitle;
		init(chooseButtonLabel);
	}

	private void init(String chooseButtonLabel) {
		m_colorPanel.setBackground(m_color);
		setLayout(new BorderLayout());
		add(m_colorPanel, BorderLayout.CENTER);
		JButton chooseButton = new JButton(chooseButtonLabel);
		add(chooseButton, BorderLayout.EAST);
		chooseButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						chooseButtonPressed();
					}
				});
	}

	public void setColor(Color color) {
	    m_color = color;
		m_colorPanel.setBackground(m_color);
	}
	public Color getColor() {
	    return m_color;
	}
	
	public void chooseButtonPressed() {
		Color selectedColor = JColorChooser.showDialog(this, m_chooseDialogTitle, m_color);
		if(selectedColor != null) {
			setColor(selectedColor);
		}
	}
}
